#include <time.h>
#include "cgic.h"
#include "tracker.h"

struct bina{
	char BinaAdi[30];
	int GEPortSayisi;
	int FEPortSayisi;
};

extern int cgiMain(void)
{
	MYSQL mysql;
	MYSQL_RES *mysqlresult;
	MYSQL_ROW mysqlrow;
    struct ayr ayarlar;
	unsigned int num_rows, i, j, BinaSayisi, CihazSayisi;
	char query[512];
	int mysql_durum, ToplamPortSayisi=0;
	time_t	curtime;
	struct tm *tmb;
	struct bina **binalar;

	time(&curtime);
	tmb = localtime(&curtime);

    cgiHeaderContentType("text/html");
    fprintf(cgiOut, "<html><head><title>Number of the Data Ports -- Ali BASEL</title></head><body bgcolor=\"#D9D9D9\">");
	fprintf(cgiOut, "<center><h2>Number of the Data Ports per Buildings</h2>");
	
	openlog("trackercgi", LOG_NOWAIT,  LOG_LOCAL1);
    
	// Reads sql hostname, username and password from CONFIG_FILE file
    if( !config_oku(&ayarlar) ) {
        printf("Please look at syslog message file for the error !\n\n");
        exit(0);
    }
    
	
    mysql_init(&mysql);
    if(!mysql_real_connect(&mysql, ayarlar.sqlhost, ayarlar.sqluser, ayarlar.sqlpass, ayarlar.sqldb, SQLPORT, NULL, 0)) {
        syslog(LOG_INFO, "Error:%s, Query:%s\n", mysql_error(&mysql), query);
        exit(0);
	}

	// Database'deki bina isimlerini bul --------------------------------------
	sprintf(query, "select distinct BuildingName from Main order by 1");
    #ifdef DEBUG
	    syslog(LOG_INFO, "DEBUG: Find the building names in the database:\nquery=%s\n", query);
    #endif


	mysql_durum=mysql_real_query(&mysql, query, strlen(query));
	if( mysql_durum ) {
		syslog(LOG_INFO, "Error:%s, Query:%s\n", mysql_error(&mysql), query);
		BinaSayisi=-1; exit(0);
	}
	else { // query succeeded, process any data returned by it
		mysqlresult = mysql_store_result(&mysql);
        num_rows = mysql_num_rows(mysqlresult);
		BinaSayisi = num_rows;
        #ifdef DEBUG
		    syslog(LOG_INFO, "DEBUG: Building number:%d\n", num_rows);
        #endif
		if( num_rows ) {
			binalar=(struct bina **)malloc( num_rows*sizeof(struct bina*) );
			for(i=0; i<num_rows; i++) {
				mysqlrow = mysql_fetch_row(mysqlresult);
				binalar[i]=(struct bina*)malloc( sizeof(struct bina));
				// ilk degerleri sifirla
				binalar[i]->BinaAdi[0]=(char)NULL;
				binalar[i]->GEPortSayisi=0;
				binalar[i]->FEPortSayisi=0;
				// Bina isimlerini structure'a tasi
				strcpy( binalar[i]->BinaAdi, mysqlrow[0] );
			}
            mysql_free_result(mysqlresult);
		}
	}

	if( !BinaSayisi) {
		syslog(LOG_INFO, "There is no building in the database !");
		exit(0);
	}
	

	// Database'deki cihaz sayilarini bul ---------------------------------------------------------------
	sprintf(query, "select GEPortSayisi, FEPortSayisi, BuildingName from Modules, Main where Modules.MainSerialNo=Main.MainSerialNo order by 2");
    #ifdef DEBUG
	    printf("DEBUG: Database'deki Cihaz Sayilarini Bul:\nquery=%s\n", query);
    #endif

	mysql_durum=mysql_real_query(&mysql, query, strlen(query));
	if( mysql_durum ) {
		syslog(LOG_INFO, "Error:%s, Query:%s\n", mysql_error(&mysql), query);
		exit(0);
	}
	else { // query succeeded, process any data returned by it
		mysqlresult = mysql_store_result(&mysql);
        num_rows = mysql_num_rows(mysqlresult);
		CihazSayisi = num_rows;
        #ifdef DEBUG
		    syslog(LOG_INFO, "DEBUG: Database'deki toplam modul sayisi:%d\n", num_rows);
        #endif
		if( num_rows ) {
			for(i=0; i<CihazSayisi; i++) {
				mysqlrow = mysql_fetch_row(mysqlresult);
				for(j=0; j<BinaSayisi; j++) {
					// Bina isimlerini ve port sayilarini structure'a tasi
					if( !strcasecmp(binalar[j]->BinaAdi, mysqlrow[2]) ) binalar[j]->GEPortSayisi += atoi(mysqlrow[0]) + atoi(mysqlrow[1]);
				}
			}
            mysql_free_result(mysqlresult);
		}
	}
	mysql_close(&mysql);
	
	
	fprintf(cgiOut, "<table border=1><tr><td>Building Name</td><td>Port Number</td></tr>\n");
	for(i=0; i<BinaSayisi; i++) {
		if( binalar[i]->GEPortSayisi )
			fprintf(cgiOut, "<tr><td>%s</td><td align=\"right\">%d</td></tr>\n", binalar[i]->BinaAdi, binalar[i]->GEPortSayisi);
		
		ToplamPortSayisi+=binalar[i]->GEPortSayisi;
		free(binalar[i]);
	}
	fprintf(cgiOut, "</table>");
	fprintf(cgiOut, "<h1>Total Port Number:%d\n</h1>", ToplamPortSayisi);
	fprintf(cgiOut, "[%2d:%2d:%4d][%d:%d:%d]\n", tmb->tm_mday, tmb->tm_mon+1, tmb->tm_year+1900, tmb->tm_hour, tmb->tm_min, tmb->tm_sec);
	fprintf(cgiOut, "</center></html>");	
	
	free(binalar);
	return(1);
}
